Package org.apache.commons.beanutils

# Class WrapDynaBean

java.lang.Object
org.apache.commons.beanutils.WrapDynaBean

All Implemented Interfaces:
  `Serializable`, `DynaBean`

Direct Known Subclasses:
  `ConvertingWrapDynaBean`

public class WrapDynaBean extends Object implements DynaBean, Serializable

Implements `DynaBean` to wrap a standard JavaBean instance, so that DynaBean APIs can be used to access its properties.

The most common use cases for this class involve wrapping an existing java bean. (This makes it different from the typical use cases for other `DynaBean`'s.) For example:

      Object aJavaBean = ...;
      ...
      DynaBean db = new WrapDynaBean(aJavaBean);
      ...

IMPLEMENTATION NOTE - This implementation does not support the `contains()` and `remove()` methods.

See Also:
  - Serialized Form

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected WrapDynaClass`
  `dynaClass`
  The `DynaClass` "base class" that this DynaBean is associated with.
  `protected Object`
  `instance`
  The JavaBean instance wrapped by this WrapDynaBean.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `WrapDynaBean(Object instance)`
  Construct a new `DynaBean` associated with the specified JavaBean instance.
  `WrapDynaBean(Object instance, WrapDynaClass cls)`
  Creates a new instance of `WrapDynaBean`, associates it with the specified JavaBean instance, and initializes the bean's `DynaClass`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `contains(String name, String key)`
  Does the specified mapped property contain a value for the specified key value?
  `Object`
  `get(String name)`
  Return the value of a simple property with the specified name.
  `Object`
  `get(String name, int index)`
  Return the value of an indexed property with the specified name.
  `Object`
  `get(String name, String key)`
  Return the value of a mapped property with the specified name, or `null` if there is no value for the specified key.
  `DynaClass`
  `getDynaClass()`
  Return the `DynaClass` instance that describes the set of properties available for this DynaBean.
  `protected DynaProperty`
  `getDynaProperty(String name)`
  Return the property descriptor for the specified property name.
  `Object`
  `getInstance()`
  Gets the bean instance wrapped by this DynaBean.
  `void`
  `remove(String name, String key)`
  Remove any existing value for the specified key on the specified mapped property.
  `void`
  `set(String name, int index, Object value)`
  Set the value of an indexed property with the specified name.
  `void`
  `set(String name, Object value)`
  Set the value of a simple property with the specified name.
  `void`
  `set(String name, String key, Object value)`
  Set the value of a mapped property with the specified name.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### dynaClass

    protected transient WrapDynaClass dynaClass
    The `DynaClass` "base class" that this DynaBean is associated with.

  - ### instance

    protected Object instance
    The JavaBean instance wrapped by this WrapDynaBean.

- ## Constructor Details

  - ### WrapDynaBean

    public WrapDynaBean(Object instance)
    Construct a new `DynaBean` associated with the specified JavaBean instance.
    Parameters:
      `instance` - JavaBean instance to be wrapped

  - ### WrapDynaBean

    public WrapDynaBean(Object instance, WrapDynaClass cls)
    Creates a new instance of `WrapDynaBean`, associates it with the specified JavaBean instance, and initializes the bean's `DynaClass`. Using this constructor this `WrapDynaBean` instance can be assigned a class which has been configured externally. If no `WrapDynaClass` is provided, a new one is created using a standard mechanism.
    Parameters:
      `instance` - JavaBean instance to be wrapped
      `cls` - the optional `WrapDynaClass` to be used for this bean
    Since:
      1.9

- ## Method Details

  - ### contains

    public boolean contains(String name, String key)
    Does the specified mapped property contain a value for the specified key value?
    Specified by:
      `contains` in interface `DynaBean`
    Parameters:
      `name` - Name of the property to check
      `key` - Name of the key to check
    Returns:
      `true` if the mapped property contains a value for the specified key, otherwise `false`
    Throws:
      `IllegalArgumentException` - if there is no property of the specified name

  - ### get

    public Object get(String name)
    Return the value of a simple property with the specified name.
    Specified by:
      `get` in interface `DynaBean`
    Parameters:
      `name` - Name of the property whose value is to be retrieved
    Returns:
      The property's value
    Throws:
      `IllegalArgumentException` - if there is no property of the specified name

  - ### get

    public Object get(String name, int index)
    Return the value of an indexed property with the specified name.
    Specified by:
      `get` in interface `DynaBean`
    Parameters:
      `name` - Name of the property whose value is to be retrieved
      `index` - Index of the value to be retrieved
    Returns:
      The indexed property's value
    Throws:
      `IllegalArgumentException` - if there is no property of the specified name
      `IllegalArgumentException` - if the specified property exists, but is not indexed
      `IndexOutOfBoundsException` - if the specified index is outside the range of the underlying property
      `NullPointerException` - if no array or List has been initialized for this property

  - ### get

    public Object get(String name, String key)
    Return the value of a mapped property with the specified name, or `null` if there is no value for the specified key.
    Specified by:
      `get` in interface `DynaBean`
    Parameters:
      `name` - Name of the property whose value is to be retrieved
      `key` - Key of the value to be retrieved
    Returns:
      The mapped property's value
    Throws:
      `IllegalArgumentException` - if there is no property of the specified name
      `IllegalArgumentException` - if the specified property exists, but is not mapped

  - ### getDynaClass

    public DynaClass getDynaClass()
    Return the `DynaClass` instance that describes the set of properties available for this DynaBean.
    Specified by:
      `getDynaClass` in interface `DynaBean`
    Returns:
      The associated DynaClass

  - ### getDynaProperty

    protected DynaProperty getDynaProperty(String name)
    Return the property descriptor for the specified property name.
    Parameters:
      `name` - Name of the property for which to retrieve the descriptor
    Returns:
      The descriptor for the specified property
    Throws:
      `IllegalArgumentException` - if this is not a valid property name for our DynaClass

  - ### getInstance

    public Object getInstance()
    Gets the bean instance wrapped by this DynaBean. For most common use cases, this object should already be known and this method safely be ignored. But some creators of frameworks using `DynaBean`'s may find this useful.
    Returns:
      the java bean Object wrapped by this `DynaBean`

  - ### remove

    public void remove(String name, String key)
    Remove any existing value for the specified key on the specified mapped property.
    Specified by:
      `remove` in interface `DynaBean`
    Parameters:
      `name` - Name of the property for which a value is to be removed
      `key` - Key of the value to be removed
    Throws:
      `IllegalArgumentException` - if there is no property of the specified name

  - ### set

    public void set(String name, int index, Object value)
    Set the value of an indexed property with the specified name.
    Specified by:
      `set` in interface `DynaBean`
    Parameters:
      `name` - Name of the property whose value is to be set
      `index` - Index of the property to be set
      `value` - Value to which this property is to be set
    Throws:
      `ConversionException` - if the specified value cannot be converted to the type required for this property
      `IllegalArgumentException` - if there is no property of the specified name
      `IllegalArgumentException` - if the specified property exists, but is not indexed
      `IndexOutOfBoundsException` - if the specified index is outside the range of the underlying property

  - ### set

    public void set(String name, Object value)
    Set the value of a simple property with the specified name.
    Specified by:
      `set` in interface `DynaBean`
    Parameters:
      `name` - Name of the property whose value is to be set
      `value` - Value to which this property is to be set
    Throws:
      `ConversionException` - if the specified value cannot be converted to the type required for this property
      `IllegalArgumentException` - if there is no property of the specified name
      `NullPointerException` - if an attempt is made to set a primitive property to null

  - ### set

    public void set(String name, String key, Object value)
    Set the value of a mapped property with the specified name.
    Specified by:
      `set` in interface `DynaBean`
    Parameters:
      `name` - Name of the property whose value is to be set
      `key` - Key of the property to be set
      `value` - Value to which this property is to be set
    Throws:
      `ConversionException` - if the specified value cannot be converted to the type required for this property
      `IllegalArgumentException` - if there is no property of the specified name
      `IllegalArgumentException` - if the specified property exists, but is not mapped